
#include <stdio.h>
#include <stdlib.h>

#include <sys/syscall.h>
#include <sys/types.h>
#include <sys/module.h>

#include <mydrv.h>

static int mysyscall_num;

static int mysyscall_init (void)
{
  struct module_stat stat;
  stat.version = sizeof(stat);
  modstat(modfind("mydrv"),&stat);
  mysyscall_num = stat.data.intval;
}

int mysyscall (int cmd, int size, int loop)
{
  int ret;
  mydrv_args_t args;

  args.cmd  = cmd;
  args.size = size;
  args.loop = loop;

  ret = syscall(mysyscall_num, &args);
  if (ret) perror("mysyscall");

  return ret;
}

int main (int argc, char* argv[])
{
  unsigned char cmd=0;
  int size, loop;

  mysyscall_init();

  if (argc<3)
  {
    printf("bad arg count\n");
    exit(-1);
  }

  cmd  = argv[1][0];
  size = atoi(argv[2]);
  loop = atoi(argv[3]);

  switch (cmd)
  {
    case 'm':
    case 'M':
    case 'b':
    case 'B':
    {
      printf("mysyscall(MALLOC,%d,%d)\n", size, loop);

      mysyscall(MYCMD_MALLOC, size, loop);

      if (cmd == 'm' || cmd == 'M') break ;
    }
    case 'f' :
    case 'F' :
    {
      printf("mysyscall(FREE),%d,%d)\n", size, loop);

      mysyscall(MYCMD_FREE, size, loop);

      break;
    }
    default:
    {
      printf("Unknown command: %c\n", cmd);

      break;
    }
  }

  return 0;
}


